#include <bits/stdc++.h>

using namespace std;

int main()
{
    int n, m, mm = 0;
    cin >> n >> m;
    vector<int> v(n);
    for(int i = 0; i < n; i++)
    {
        float x;
        cin >> x;
        v[i] =(int)log2(x);
        //cout << v[i] << " ";
        if(v[i] > mm) mm = v[i];
    }
    for(int i = 0; i < m; i++)
    {
        int l, r;
        int ans;
        cin >> l >> r;
        if(l == r) cout << 1;
        else
        {
            int ans = 0;
            vector<int> t(mm + 1);
            for(int j = l - 1; j < r; j++)
            {
                t[v[j]]++;
                if(t[v[j]] > ans) ans = t[v[j]];
            }
            cout << ans;
        }
    }

}